package aggtool.metadata;

import java.util.ArrayList;

import aggtool.ui.DAPPanel;
import aggtool.ui.RDTypePanel;
import aggtool.ui.RawDataPanel;
import aggtool.z3.Z3Utils;

public class DAPSpec {
	public String name;
	public ArrayList<RDTypeSpec> rawdatatypelist = new ArrayList<RDTypeSpec>();
	public String af;
	public AggregatedDataSpec aggdata = new AggregatedDataSpec("AggregatedData");
	public boolean hasRealTime = false;
	public boolean hasDurable = false;
	
	public DAPSpec(String n) {
		this.name = n;
	}
	
	public DAPSpec(DAPSpec dap) {
		this.name = dap.name;
		this.af = dap.af;
		this.hasDurable = dap.hasDurable;
		this.hasRealTime = dap.hasRealTime;
		
	}
	

	public void addRDTypeSpecSpec(RDTypeSpec r) {
		this.rawdatatypelist.add(r);
	}
	
	public static DAPSpec createDAPSpecFromPanel(DAPPanel dap) {
		String DAPName = dap.txtName.getText();
		DAPSpec dapspec = new DAPSpec(DAPName);
		for(RDTypePanel rdt: dap.rdtypepanels) {
			String rdtname = rdt.txtName.getText();
			RDTypeSpec rdtspec = new RDTypeSpec(rdtname);
			for(RawDataPanel rd: rdt.rdpanels) {
				String rdname = rd.txtName.getText();
				RawDataSpec rdspec = new RawDataSpec(rdname);
				rdspec.hasRT = rd.cbRT.isSelected();
				rdspec.hasHard = rd.cbRT.isSelected() && rd.rbHard.isSelected();
				rdspec.hasFirm = rd.cbRT.isSelected()  && rd.rbFirm.isSelected();
				rdspec.hasSoft = rd.cbRT.isSelected() && rd.rbSoft.isSelected();
				rdtspec.addRawDataSpec(rdspec);
				if(rd.cbRT.isSelected()) 
					dapspec.hasRealTime = true;
				if(rd.cbPersistent.isSelected())
					dapspec.hasDurable = true;
			}
			dapspec.addRDTypeSpecSpec(rdtspec);
		}
		dapspec.af = dap.pAggregateFunction.txtName.getText();
		dapspec.aggdata.name = dap.pAggregatedData.txtName.getText();
		dapspec.aggdata.hasRT = dap.pAggregatedData.cbRT.isSelected();
		dapspec.aggdata.hasHard = dap.pAggregatedData.cbRT.isSelected() && dap.pAggregatedData.rbHard.isSelected();
		dapspec.aggdata.hasFirm = dap.pAggregatedData.cbRT.isSelected() && dap.pAggregatedData.rbFirm.isSelected();
		dapspec.aggdata.hasSoft = dap.pAggregatedData.cbRT.isSelected() && dap.pAggregatedData.rbSoft.isSelected();
		if(dap.pAggregatedData.cbRT.isSelected()) 
			dapspec.hasRealTime = true;
		if(dap.pRTProcess.cbRTPEnable.isSelected())
			dapspec.hasRealTime = true;

		if(dap.pAggregatedData.cbDurable.isSelected())
			dapspec.hasDurable = true;
		return dapspec;
	}
	
	public String toString() {

		return this.name;
	}
}
