package aggtool.metadata;

import java.util.ArrayList;

public class Taxonomy {
	public static AggNode root;
	
	public static AggNode getTaxonomy() {
		if(root == null) initiate();
		return root;
	}
	
	public static void initiate(){
		
		//Raw Data subtree...
		
		AggNode RawDataType = initRawDataType();
		
		//Agg function subtree..
		AggNode AggregateFunction = initAggregateFunction();
		
		//Aggregated Data...
		AggNode AggregatedData = initAggregatedData();

		//TriggeringPattern...
		AggNode TriggeringPattern = initTriggerPattern();
		
		//RealTimeP...
		AggNode RealTimeP = initTimeliness();
		
		//root...
		ArrayList<AggNode> RootChildren = new ArrayList<AggNode>();
		RootChildren.add(RawDataType);
		RootChildren.add(AggregateFunction);
		RootChildren.add(AggregatedData);
		RootChildren.add(TriggeringPattern);
		RootChildren.add(RealTimeP);
		root = new AggNode("Data Aggregation Process", "Data Aggregation Process", "Data Aggregation Process", true, false, false, null, RootChildren);
	}
	
	private static AggNode initRawDataType() {
		
		AggNode RawData = initRawData();
		ArrayList<AggNode> RawDataTypeChildren = new ArrayList<AggNode>();
		
		RawDataTypeChildren.add(RawData);
		AggNode RawDataType = new AggNode("Raw Data Type", "Raw Data Type", null, true, false, true, null, RawDataTypeChildren);
		
		return RawDataType;
	}
	
	private static AggNode initRawData() {
		AggNode RDAVI = new AggNode("AVI", "Absolute Validity Interval", null, true, false, false, null, null);
		
		AggNode RDMINT = new AggNode("MINT", "MINT", null, false, false, false, null, null);
		AggNode RDMAXT = new AggNode("MAXT", "MAXT", null, false, false, false, null, null);
		
		AggNode RDHard = new AggNode("Hard", "Hard", null, false, false, false, null, null);
		AggNode RDFirm = new AggNode("Firm", "Firm", null, false, false, false, null, null);
		AggNode RDSoft = new AggNode("Soft", "Soft", null, false, false, false, null, null);
		ArrayList<AggNode> RDHardFirmSoftMembers = new ArrayList<AggNode>();
		RDHardFirmSoftMembers.add(RDHard);
		RDHardFirmSoftMembers.add(RDFirm);
		RDHardFirmSoftMembers.add(RDSoft);
		AggNode RDHardFirmSoft = new AggNode("HardFirmSoftGroup", "HardFirmSoftGroup", null, false, false, true, RDHardFirmSoftMembers, null);
		
		ArrayList<AggNode> RDRealTimeChildren = new ArrayList<AggNode>();
		RDRealTimeChildren.add(RDAVI);
		RDRealTimeChildren.add(RDHardFirmSoft);
		AggNode RDRealTime = new AggNode("Real-Time", "Real-Time", null, false, false, false, null, RDRealTimeChildren);
		
		AggNode RDPersistent = new AggNode("Persistently Stored", "Persistently Stored", null, false, false, false, null, null);
		ArrayList<AggNode> RDPullChildren = new ArrayList<AggNode>();
		RDPullChildren.add(RDPersistent);
		AggNode RDPull = new AggNode("Pull", "Pull", null, false, false, false, null, RDPullChildren);
		
		AggNode RDShare = new AggNode("Share", "Share", null, false, false, false, null, null);
		
		AggNode RDSheddable = new AggNode("Sheddable", "Sheddable", null, false, false, false, null, null);
		
		ArrayList<AggNode> RawDataChildren = new ArrayList<AggNode>();
		RawDataChildren.add(RDPull);
		RawDataChildren.add(RDShare);
		RawDataChildren.add(RDSheddable);
		RawDataChildren.add(RDRealTime);
		RawDataChildren.add(RDMAXT);
		RawDataChildren.add(RDMINT);
		AggNode RawData = new AggNode("Raw Data", "Raw Data", null, true, false, true, null, RawDataChildren);
		
		return RawData;
	}
	
	private static AggNode initAggregateFunction() {

		AggNode AFDuplicate = new AggNode("Dupplicate Sensitive", "Dupplicate Sensitive", null, false, false, false, null, null);

		AggNode AFLossy = new AggNode("Lossy", "Lossy", null, false, false, false, null, null);

			
		AggNode AFExemplary= new AggNode("Exemplary", "Exemplary", null, false, false, false, null, null);
		AggNode AFSummary = new AggNode("Summary", "Summary", null, false, false, false, null, null);
		ArrayList<AggNode> AFExemSumMembers = new ArrayList<AggNode>();
		AFExemSumMembers.add(AFExemplary);
		AFExemSumMembers.add(AFSummary);
		AggNode AFExemSumGroup = new AggNode("ExemSumGroup", "ExemSumGroup", null, false, false, true, AFExemSumMembers, null);
		
		AggNode AFHolistic= new AggNode("Holistic", "Holistic", null, false, false, false, null, null);
		AggNode AFProgressive = new AggNode("Progressive", "Progressive", null, false, false, false, null, null);
		ArrayList<AggNode> AFHolProgMembers = new ArrayList<AggNode>();
		AFHolProgMembers.add(AFHolistic);
		AFHolProgMembers.add(AFProgressive);
		AggNode AFHolProgGroup = new AggNode("HolProgGroup", "HolProgGroup", null, false, false, true, AFHolProgMembers, null);
		
		ArrayList<AggNode> AFChildren = new ArrayList<AggNode>();
		
		AFChildren.add(AFDuplicate);
		AFChildren.add(AFLossy);
		AFChildren.add(AFExemSumGroup);
		AFChildren.add(AFHolProgGroup);
		AggNode AggregateFunction = new AggNode("Aggregate Function", "Aggregate Function", null, true, false, false, null, AFChildren);
		
		return AggregateFunction;
	}
	
	
	private static AggNode initAggregatedData() {
		AggNode ADAVI = new AggNode("Absolute Validity Interval", "Absolute Validity Interval", null, true, false, false, null, null);
		AggNode ADRVI = new AggNode("Relative Validity Interval", "Relative Validity Interval", null, true, false, false, null, null);
				
		AggNode ADHard = new AggNode("Hard", "Hard", null, false, false, false, null, null);
		AggNode ADFirm = new AggNode("Firm", "Firm", null, false, false, false, null, null);
		AggNode ADSoft = new AggNode("Soft", "Soft", null, false, false, false, null, null);
		ArrayList<AggNode> ADHardFirmSoftMembers = new ArrayList<AggNode>();
		ADHardFirmSoftMembers.add(ADHard);
		ADHardFirmSoftMembers.add(ADFirm);
		ADHardFirmSoftMembers.add(ADSoft);
		AggNode ADHardFirmSoft = new AggNode("HardFirmSoftGroup", "HardFirmSoftGroup", null, false, false, true, ADHardFirmSoftMembers, null);
		
		ArrayList<AggNode> ADRealTimeChildren = new ArrayList<AggNode>();
		ADRealTimeChildren.add(ADAVI);
		ADRealTimeChildren.add(ADRVI);
		ADRealTimeChildren.add(ADHardFirmSoft);
		AggNode ADRealTime = new AggNode("Real-Time", "Real-Time", null, false, false, false, null, ADRealTimeChildren);
		

		AggNode ADDurable = new AggNode("Durable", "Durable", null, false, false, false, null, null);

		ArrayList<AggNode> ADPushChildren = new ArrayList<AggNode>();
		ADPushChildren.add(ADDurable);
		AggNode ADPush = new AggNode("Push", "Push", null, false, false, false, null, ADPushChildren);
		
		AggNode ADShare = new ShareNode("Share", "Share", null, false, false, false, null, null);
		
		AggNode ADTTL = new ShareNode("Time-to-live", "Time-to-live", null, false, false, false, null, null);
		
		ArrayList<AggNode> AggregatedDataChildren = new ArrayList<AggNode>();
		AggregatedDataChildren.add(ADPush);
		AggregatedDataChildren.add(ADShare);
		AggregatedDataChildren.add(ADTTL);
		AggregatedDataChildren.add(ADRealTime);
		AggNode AggregatedData = new AggNode("Aggregated Data", "Aggregated Data", null, true, false, false, null, AggregatedDataChildren);
		
		return AggregatedData;
	}
	

	private static AggNode initTriggerPattern() {
		AggNode TPAPEvents = new AggNode("Events", "Events", null, true, false, false, null, null);
		
		ArrayList<AggNode> TPAperiodicChildren = new ArrayList<AggNode>();
		TPAperiodicChildren.add(TPAPEvents);
		AggNode TPAperiodic = new AggNode("Aperiodic", "Aperiodic", null, false, false, false, null, TPAperiodicChildren);
		
		AggNode TPPeriod = new AggNode("Period", "Period", null, true, false, false, null, null);
		
		ArrayList<AggNode> TPPeriodicChildren = new ArrayList<AggNode>();
		TPPeriodicChildren.add(TPPeriod);
		AggNode TPPeriodic = new AggNode("Periodic", "Periodic", null, false, false, false, null, TPPeriodicChildren);
		
		AggNode TPSPEvents = new AggNode("Events", "Events", null, false, false, false, null, null);
		AggNode TPSPMINT = new AggNode("MINT", "MINT", null, false, false, false, null, null);
		AggNode TPSPMAXT = new AggNode("MAXT", "MAXT", null, false, false, false, null, null);
		
		ArrayList<AggNode> TPSporadicChildren = new ArrayList<AggNode>();
		TPSporadicChildren.add(TPSPEvents);
		TPSporadicChildren.add(TPSPMINT);
		TPSporadicChildren.add(TPSPMAXT);
		AggNode TPSporadic = new AggNode("Sporadic", "Sporadic", null, false, false, false, null, TPPeriodicChildren);
		
		ArrayList<AggNode> TPGroupMembers = new ArrayList<AggNode>();
		TPGroupMembers.add(TPAperiodic);
		TPGroupMembers.add(TPPeriodic);
		TPGroupMembers.add(TPSporadic);
		AggNode TPGroup = new AggNode("TPGroup", "TPGroup", null, false, false, true, TPGroupMembers, null);

		ArrayList<AggNode> TPChildren = new ArrayList<AggNode>();
		TPChildren.add(TPGroup);
		AggNode TriggeringPattern = new AggNode("Triggering Pattern", "Triggering Pattern", null, true, false, false, null, TPChildren);
		
		return TriggeringPattern;
	}
	
	private static AggNode initTimeliness() {
		AggNode TDeadline = new AggNode("Deadline", "Deadline", null, true, false, false, null, null);
				
		AggNode THard = new AggNode("Hard", "Hard", null, false, false, false, null, null);
		AggNode TFirm = new AggNode("Firm", "Firm", null, false, false, false, null, null);
		AggNode TSoft = new AggNode("Soft", "Soft", null, false, false, false, null, null);
		ArrayList<AggNode> THardFirmSoftMembers = new ArrayList<AggNode>();
		THardFirmSoftMembers.add(THard);
		THardFirmSoftMembers.add(TFirm);
		THardFirmSoftMembers.add(TSoft);
		AggNode THardFirmSoft = new AggNode("HardFirmSoftGroup", "HardFirmSoftGroup", null, false, false, true, THardFirmSoftMembers, null);
		
		ArrayList<AggNode> TimelinessChildren = new ArrayList<AggNode>();
		TimelinessChildren.add(TDeadline);
		TimelinessChildren.add(THardFirmSoft);
		AggNode RealTimeP = new AggNode("Real-Time", "Real-Time", null, false, false, false, null, TimelinessChildren);
				
		return RealTimeP;
	}
	
	
	public static void printNode(AggNode node) {
		System.out.println("node name is " + node.name);
		if(node.isGroup) {
			for(AggNode member: node.groupmembers)
			printNode(member);
		}
		if(node.children!=null) {
			for(AggNode child: node.children)
				printNode(child);
		}
	}
	
	public static void main(String[] args) {
		AggNode taxonomy = Taxonomy.getTaxonomy();
		Taxonomy.printNode(taxonomy);
	}
}
