package aggtool.ui;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.util.ArrayList;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;

import com.microsoft.z3.Context;

import aggtool.metadata.DAPFormulas;
import aggtool.z3.Z3Analyzer;

public class AggGUIMainFrame extends JFrame {
	//public static ArrayList<DAPFormulas> DAPFormulaList = new ArrayList<DAPFormulas>();
	public static Z3Analyzer analyzer = new Z3Analyzer();
	public AggGUIMainFrame(String name) {
		super(name);
	}

	public static void main(String[] args) {

		javax.swing.SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				try {
					// Set cross-platform Java L&F (also called "Metal")
					UIManager.setLookAndFeel(UIManager
							.getSystemLookAndFeelClassName());
				} catch (UnsupportedLookAndFeelException e) {
					// handle exception
				} catch (ClassNotFoundException e) {
					// handle exception
				} catch (InstantiationException e) {
					// handle exception
				} catch (IllegalAccessException e) {
					// handle exception
				}

				// Create a frame
				AggGUIMainFrame frame = new AggGUIMainFrame("DAPComposer");
				frame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
				JTabbedPane tabbedPane = new JTabbedPane();
				DAPListPanel dappanel = new DAPListPanel( analyzer);
				tabbedPane.addTab("DAP Specification", new JScrollPane(dappanel));
				CheckPanel checkpanel = new CheckPanel(analyzer);
				tabbedPane.addTab("Consistency Check", checkpanel);
				DBMSListPanel dbmspanel = new DBMSListPanel(analyzer);
				tabbedPane.addTab("DBMS Specification", dbmspanel);
				//DependencyPanel deppanel = new DependencyPanel(analyzer);
				//tabbedPane.addTab("Dependency Specification", deppanel);
				frame.getContentPane().setLayout(new BorderLayout());
				frame.getContentPane().add(tabbedPane, BorderLayout.CENTER);
				

			    frame.setBounds(200,200,1000,500);
				
				// Display the frame
				frame.pack();
				frame.setVisible(true);
				//frame.setResizable(false);
			}

		});
	}

}
