package aggtool.ui;

import java.awt.Component;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.ImageIcon;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;
import javax.swing.border.EmptyBorder;

public class AggregateFunctionPanel extends JPanel {
	public JCheckBox cbDuplicate = new JCheckBox("DuplicateSensitive");
	public JCheckBox cbLossy = new JCheckBox("Lossy");
	
	public ButtonGroup groupExemSum = new ButtonGroup();
	public JRadioButton rbExem = new JRadioButton("Exemplary");
	public JRadioButton rbSum = new JRadioButton("Summary");
	

	public ButtonGroup groupHolProg = new ButtonGroup();
	public JRadioButton rbProg = new JRadioButton("Progressive");
	public JRadioButton rbHol = new JRadioButton("Holistic");
	

	public JTextField txtName = new JTextField("AggregateFunction");

	public ImageIcon tipIcon = new ImageIcon("rsc/exclamation.png");
	JLabel lDupTip = new JLabel();
	JLabel lLossyTip = new JLabel();
	JLabel lProgTip = new JLabel();
	
	public AggregateFunctionPanel() {
		super();

		initialize();
		
	}
	
	void initialize() {
		this.setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
		this.setBorder(BorderFactory.createTitledBorder("Aggregate Function"));
		((javax.swing.border.TitledBorder) this.getBorder()).setTitleFont(new Font("Arial", Font.BOLD, 14));
		this.setAlignmentY(Component.TOP_ALIGNMENT);
		//this.setPreferredSize(new Dimension(200, 500));
		
		JPanel pName = new JPanel(new FlowLayout());
		pName.add(new JLabel("Function Name: "));
		txtName.setPreferredSize(new Dimension(100, 20));
		pName.add(txtName);
		this.add(pName);
		
		JPanel pDup = new JPanel(new FlowLayout(FlowLayout.LEFT));
		pDup.add(cbDuplicate);
		lDupTip.setIcon(tipIcon);
		lDupTip.setToolTipText("Consider to implement filtering for the duplicate sensitive aggregate function.");
		pDup.add(lDupTip);
		lDupTip.setVisible(false);
		this.add(pDup);
		
		JPanel pLossy = new JPanel(new FlowLayout(FlowLayout.LEFT));
		pLossy.add(cbLossy);
		lLossyTip.setIcon(tipIcon);
		lLossyTip.setToolTipText("Consider to implement caching for the lossy aggregate function.");
		pLossy.add(lLossyTip);
		lLossyTip.setVisible(false);
		this.add(pLossy);
		
		groupExemSum.add(rbExem);
		groupExemSum.add(rbSum);
		JPanel pGroupExemSum = new JPanel();
		pGroupExemSum.setBorder(BorderFactory.createTitledBorder(""));
		pGroupExemSum.setLayout(new BoxLayout(pGroupExemSum, BoxLayout.Y_AXIS));
		pGroupExemSum.add(rbExem);
		pGroupExemSum.add(rbSum);
		rbExem.setSelected(true);
		JPanel pGroupExemSumUpper = new JPanel(new FlowLayout(FlowLayout.LEFT));
		pGroupExemSumUpper.add(pGroupExemSum);
		this.add(pGroupExemSumUpper);
		
		groupHolProg.add(rbProg);
		groupHolProg.add(rbHol);
		JPanel pGroupHolProg = new JPanel();
		pGroupHolProg.setBorder(BorderFactory.createTitledBorder(""));
		pGroupHolProg.setLayout(new BoxLayout(pGroupHolProg, BoxLayout.Y_AXIS));
		pGroupHolProg.add(rbProg);
		pGroupHolProg.add(rbHol);
		rbProg.setSelected(true);

		JPanel pGroupHolProgUpper = new JPanel(new FlowLayout(FlowLayout.LEFT));
		pGroupHolProgUpper.add(pGroupHolProg);
		this.add(pGroupHolProgUpper);
		
		implementRules();
	}
	
	void implementRules() {
		cbDuplicate.addItemListener(new ItemListener() {

		    public void itemStateChanged(ItemEvent e) {
		    	if(e.getStateChange() == ItemEvent.DESELECTED) {
		    		lDupTip.setVisible(false);
		    	} else {

		    		lDupTip.setVisible(true);
		    	}
		    }
		});
		
		cbLossy.addItemListener(new ItemListener() {

		    public void itemStateChanged(ItemEvent e) {
		    	if(e.getStateChange() == ItemEvent.DESELECTED) {
		    		lLossyTip.setVisible(false);
		    	} else {

		    		lLossyTip.setVisible(true);
		    	}
		    }
		});
	}
}
