package aggtool.ui;

import java.awt.Component;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.ImageIcon;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;
import javax.swing.border.EmptyBorder;

public class AggregatedDataPanel extends JPanel{
	public JCheckBox cbPush = new JCheckBox("Push");
	public JCheckBox cbDurable = new JCheckBox("Durable");
	public JCheckBox cbShared = new JCheckBox("Shared");
	public JCheckBox cbTTL = new JCheckBox("Time-To-Live");
	public JCheckBox cbRT = new JCheckBox("RealTime");
	public JCheckBox cbAVI = new JCheckBox("AVI");
	public JCheckBox cbRVI = new JCheckBox("RVI");
	public JTextField txtName = new JTextField("AggregatedData");
	
	public ButtonGroup groupHardFirmSoft = new ButtonGroup();
	public JRadioButton rbHard = new JRadioButton("Hard");
	public JRadioButton rbFirm = new JRadioButton("Firm");
	public JRadioButton rbSoft = new JRadioButton("Soft");
	public ImageIcon tipIcon = new ImageIcon("rsc/exclamation.png");
	

	JLabel lPushTip = new JLabel();
	JLabel lDurableTip = new JLabel();
	JLabel lSharedTip = new JLabel();
	JLabel lTTLTip = new JLabel();
	
	public AggregatedDataPanel() {
		super();

		initialize();
		
	}
	
	void initialize() {
		this.setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
		this.setBorder(BorderFactory.createTitledBorder("Aggregated Data"));
		((javax.swing.border.TitledBorder) this.getBorder()).setTitleFont(new Font("Arial", Font.BOLD, 14));

		JPanel pName = new JPanel(new FlowLayout());
		pName.add(new JLabel("Aggregated Data Name: "));
		txtName.setPreferredSize(new Dimension(100, 20));
		pName.add(txtName);
		
		this.add(pName);
		
		JPanel pPush = new JPanel(new FlowLayout(FlowLayout.LEFT));
		//pPull.setBorder(new EmptyBorder (0, 5, 0, 0));
		pPush.add(cbPush);
		lPushTip.setIcon(tipIcon);
		lPushTip.setToolTipText("Consider to implement synchronization for the pushed data.");
		pPush.add(lPushTip);
		lPushTip.setVisible(false);
		this.add(pPush);
		
		JPanel pDurable = new JPanel(new FlowLayout(FlowLayout.LEFT));
		pDurable.setBorder(new EmptyBorder (0, 15, 0, 0));
		pDurable.add(cbDurable);	
		lDurableTip.setIcon(tipIcon);
		lDurableTip.setToolTipText("Consider to use logging and recovery mechanism for the durable data.");
		pDurable.add(lDurableTip);
		lDurableTip.setVisible(false);
		this.add(pDurable);
		

		cbDurable.setEnabled(false);
		
		JPanel pShared = new JPanel(new FlowLayout(FlowLayout.LEFT));
		pShared.add(cbShared);		
		lSharedTip.setIcon(tipIcon);
		lSharedTip.setToolTipText("Consider to use concurrency control for the shared data.");
		pShared.add(lSharedTip);
		lSharedTip.setVisible(false);
		this.add(pShared);
		
		JPanel pTTL = new JPanel(new FlowLayout(FlowLayout.LEFT));
		pTTL.add(cbTTL);		
		lTTLTip.setIcon(tipIcon);
		lTTLTip.setToolTipText("Consider to implement buffering mechanism for the shared data.");
		pTTL.add(lTTLTip);
		lTTLTip.setVisible(false);
		this.add(pTTL);
		
		JPanel pRT = new JPanel(new FlowLayout(FlowLayout.LEFT));
		pRT.add(cbRT);
		this.add(pRT);
		
		JPanel pAVI = new JPanel(new FlowLayout(FlowLayout.LEFT));
		pAVI.setBorder(new EmptyBorder (0, 15, 0, 0));
		pAVI.setName("RealTime");
		pAVI.add(cbAVI);
		this.add(pAVI);
		//pAVI.setAlignmentX(Component.LEFT_ALIGNMENT);
		
		JPanel pRVI = new JPanel(new FlowLayout(FlowLayout.LEFT));
		pRVI.setBorder(new EmptyBorder (0, 15, 0, 0));
		pRVI.setName("RealTime");
		pRVI.add(cbRVI);
		this.add(pRVI);
		//pRVI.setAlignmentX(Component.LEFT_ALIGNMENT);
		
		groupHardFirmSoft.add(rbHard);
		groupHardFirmSoft.add(rbFirm);
		groupHardFirmSoft.add(rbSoft);
		JPanel pGroup = new JPanel();
		pGroup.setLayout(new BoxLayout(pGroup, BoxLayout.Y_AXIS));
		pGroup.setName("RealTime");
		pGroup.add(rbHard);
		pGroup.add(rbFirm);
		pGroup.add(rbSoft);
		

		cbAVI.setEnabled(false);
		cbRVI.setEnabled(false);
		rbHard.setEnabled(false);
		rbFirm.setEnabled(false);
		rbSoft.setEnabled(false);
		rbHard.setSelected(true);
		
		JPanel pGroupUpper = new JPanel(new FlowLayout(FlowLayout.LEFT));
		pGroupUpper.setBorder(new EmptyBorder (0, 15, 0, 0));
		pGroupUpper.add(pGroup);
		//pGroupUpper.setAlignmentX(Component.LEFT_ALIGNMENT);
		this.add(pGroupUpper);
		

		implementRules();
	}
	
	void implementRules() {
		cbPush.addItemListener(new ItemListener() {

		    public void itemStateChanged(ItemEvent e) {
		    	if(e.getStateChange() == ItemEvent.DESELECTED) {
		    		lPushTip.setVisible(false);
		    		cbDurable.setSelected(false);
		    		cbDurable.setEnabled(false);
		    	} else {

		    		lPushTip.setVisible(true);
		    		cbDurable.setEnabled(true);
		    	}
		    }
		});
		
		cbDurable.addItemListener(new ItemListener() {

		    public void itemStateChanged(ItemEvent e) {
		    	if(e.getStateChange() == ItemEvent.DESELECTED) {
		    		lDurableTip.setVisible(false);
		    	} else {

		    		lDurableTip.setVisible(true);
		    	}
		    }
		});
		
		cbShared.addItemListener(new ItemListener() {

		    public void itemStateChanged(ItemEvent e) {
		    	if(e.getStateChange() == ItemEvent.DESELECTED) {
		    		lSharedTip.setVisible(false);
		    	} else {

		    		lSharedTip.setVisible(true);
		    	}
		    }
		});
		
		cbTTL.addItemListener(new ItemListener() {

		    public void itemStateChanged(ItemEvent e) {
		    	if(e.getStateChange() == ItemEvent.DESELECTED) {
		    		lTTLTip.setVisible(false);
		    	} else {

		    		lTTLTip.setVisible(true);
		    	}
		    }
		});

		cbRT.addItemListener(new ItemListener() {

		    public void itemStateChanged(ItemEvent e) {
		    	if(e.getStateChange() == ItemEvent.DESELECTED) {
		    		cbAVI.setSelected(false);
		    		cbAVI.setEnabled(false);
		    		cbRVI.setSelected(false);
		    		cbRVI.setEnabled(false);
		    		rbHard.setSelected(false);
		    		rbHard.setEnabled(false);
		    		rbFirm.setSelected(false);
		    		rbFirm.setEnabled(false);
		    		rbSoft.setSelected(false);
		    		rbSoft.setEnabled(false);
		    	} else {
		    		cbAVI.setEnabled(true);
		    		cbAVI.setSelected(true);
		    		cbRVI.setEnabled(true);
		    		cbRVI.setSelected(true);
		    		rbHard.setEnabled(true);
		    		rbFirm.setEnabled(true);
		    		rbSoft.setEnabled(true);
		    	}
		    }
		});
		
		cbAVI.addItemListener(new ItemListener() {

		    public void itemStateChanged(ItemEvent e) {
		    	if(e.getStateChange() == ItemEvent.DESELECTED) {
		    		cbRT.setSelected(false);
		    	} else {

		    		cbRT.setSelected(true);
		    	}
		    }
		});
		
		cbRVI.addItemListener(new ItemListener() {

		    public void itemStateChanged(ItemEvent e) {
		    	if(e.getStateChange() == ItemEvent.DESELECTED) {
		    		cbRT.setSelected(false);
		    	} else {

		    		cbRT.setSelected(true);
		    	}
		    }
		});
	}
}
