package aggtool.ui;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextField;

import com.microsoft.z3.Context;

import aggtool.metadata.DAPFormulas;

public class DAPPanel extends JPanel {
	public int nrRDType = 1;
	public ArrayList<RDTypePanel> rdtypepanels = new ArrayList<RDTypePanel>();
	public JTextField txtName = new JTextField();
	public JPanel rdtypelistpanel =  new JPanel(new FlowLayout());
	public AggregateFunctionPanel pAggregateFunction = new AggregateFunctionPanel();
	public AggregatedDataPanel pAggregatedData = new AggregatedDataPanel();
	public TriggeringPatternPanel pTP = new TriggeringPatternPanel();
	public RealTimeProcessPanel pRTProcess = new RealTimeProcessPanel();
	public JButton btAddRDType = new JButton("New Raw Data Type");
	public ArrayList<DAPFormulas> DAPFormulaList;
	public Context z3context;

	
	public DAPPanel() {
		super();
		initialize();
	}
	
	void initialize() {
		this.setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
		this.setBorder(BorderFactory.createTitledBorder("Data Aggregation Process"));
		((javax.swing.border.TitledBorder) this.getBorder()).setTitleFont(new Font("Arial", Font.BOLD, 16));

		JPanel pName = new JPanel(new FlowLayout());
		pName.add(new JLabel("DAP Name: "));
		txtName.setPreferredSize(new Dimension(200, 20));
		pName.add(txtName);
		
		this.add(pName);

		JPanel pbutton = new JPanel(new FlowLayout(FlowLayout.LEFT));
		pbutton.add(btAddRDType);
		this.add(pbutton);
		
		JPanel pTax = new JPanel(new FlowLayout());
		
		
		RDTypePanel rdtypepanel1 = new RDTypePanel();
		rdtypepanel1.txtName.setText("RDT"+(rdtypepanels.size()+1));
		rdtypepanels.add(rdtypepanel1);
		rdtypelistpanel.add(rdtypepanel1);
		
		pTax.add(rdtypelistpanel);
		pTax.add(pAggregateFunction);
		pTax.add(pAggregatedData);
		pTax.add(pTP);
		pTax.add(pRTProcess);
		

		JScrollPane scrollPane = new JScrollPane();
		scrollPane.setViewportView(pTax);
		scrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
		scrollPane.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
		this.add(scrollPane);
		implementRules();
	}
	
	void implementRules() {
		btAddRDType.addActionListener(new ActionListener()
		{
			  public void actionPerformed(ActionEvent e)
			  {
			    // display/center the jdialog when the button is pressed
				  addNewRawDataType();
			  }
			});
	}
	
	public void addNewRawDataType() {
		RDTypePanel rdtpanel = new RDTypePanel();
		rdtpanel.txtName.setText("RDT"+(rdtypepanels.size()+1));
		rdtypepanels.add(rdtpanel);
		rdtypelistpanel.add(rdtpanel);
		rdtypelistpanel.revalidate();
		rdtypelistpanel.repaint();
	}
}
