package aggtool.ui;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.util.ArrayList;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JScrollPane;

import aggtool.z3.Z3Analyzer;

public class DBMSSelectionUpperPanel extends JPanel {
	public Z3Analyzer z3analyzer;

	public JButton btDBMSBinding = new JButton("New DAP/DBMS binding");
	public JButton btClear = new JButton("Clear all bindings");
	public JButton btLoadDBMSBinding = new JButton("Load all DAP/DBMS bindings");
	public ArrayList<DBMSSelectionPanel> bindinglist = new ArrayList<DBMSSelectionPanel>();
	public JPanel bindinglistpanel = new JPanel();
	public JPanel dbmsdappanel = new JPanel();
	
	public DBMSSelectionUpperPanel(Z3Analyzer z) {
		super();
		z3analyzer = z;
		initialize();
		implementRules();
	}
	
	void initialize() {
		//DBMSSelectionPanel
		this.setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
		
		dbmsdappanel.setLayout(new BorderLayout());
		dbmsdappanel.setBorder(BorderFactory.createTitledBorder("Bind DAP with DBMS"));
		((javax.swing.border.TitledBorder) dbmsdappanel.getBorder()).setTitleFont(new Font("Arial", Font.BOLD, 14));
		JPanel pbutton = new JPanel(new FlowLayout(FlowLayout.LEFT));
		pbutton.add(btDBMSBinding);
		pbutton.add(btClear);
		dbmsdappanel.add(pbutton, BorderLayout.NORTH);
		bindinglistpanel.setLayout(new BoxLayout(bindinglistpanel, BoxLayout.Y_AXIS));
		DBMSSelectionPanel bindingpanel = new DBMSSelectionPanel(z3analyzer);
		bindinglist.add(bindingpanel);
		bindinglistpanel.add(bindingpanel);
		JScrollPane scrollPane = new JScrollPane(bindinglistpanel);
		dbmsdappanel.add(scrollPane, BorderLayout.CENTER);
		JPanel pbutton2 = new JPanel(new FlowLayout(FlowLayout.LEFT));
		pbutton2.add(btLoadDBMSBinding);
		dbmsdappanel.add(pbutton2, BorderLayout.SOUTH);
		this.add(dbmsdappanel);
	}

	void implementRules() {
		btDBMSBinding.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				addNewDBMSBiding();
			}
		});

		btClear.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				clearAll();
			}
		});
		
	}
	
	public void addNewDBMSBiding() {
		DBMSSelectionPanel bindingpanel = new DBMSSelectionPanel(z3analyzer);
		bindinglist.add(bindingpanel);
		bindinglistpanel.add(bindingpanel);
		bindinglistpanel.revalidate();
		bindinglistpanel.repaint();
	}

	public void clearAll() {
		// TODO Auto-generated method stub
		z3analyzer.DBMSConstraints.clear();
		bindinglist.clear();
		bindinglistpanel.removeAll();
		DBMSSelectionPanel bindingpanel = new DBMSSelectionPanel(z3analyzer);
		bindinglist.add(bindingpanel);
		bindinglistpanel.add(bindingpanel);

		this.revalidate();
		this.repaint();
	}

}
