package aggtool.ui;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.util.ArrayList;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JPanel;

import aggtool.z3.Z3Analyzer;

public class DependencyPanel extends JPanel {
	public Z3Analyzer z3analyzer;
	public JButton btDBMSBinding = new JButton("New DAP/DBMS binding");
	public JButton btLoadDBMSBinding = new JButton("Load all DAP/DBMS bindings");
	public ArrayList<DBMSSelectionPanel> bindinglist = new ArrayList<DBMSSelectionPanel>();
	public JPanel bindinglistpanel = new JPanel();
	public JPanel dbmsdappanel = new JPanel();

	public JButton btDAPBinding = new JButton("New inter-DAP binding");
	public JButton btLoadDAPBinding = new JButton("Load all inter-DAP bindings");
	public ArrayList<InterDAPDependencyPanel_deprecated> dapdependencylist = new ArrayList<InterDAPDependencyPanel_deprecated>();
	public JPanel dapdependencylistpanel = new JPanel();
	public JPanel interdappanel = new JPanel();
	
	public DependencyPanel(Z3Analyzer z) {
		super();
		z3analyzer = z;
		initialize();
		implementRules();
	}
	
	void initialize() {
		//DBMSSelectionPanel
		this.setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
		
		dbmsdappanel.setLayout(new BorderLayout());
		dbmsdappanel.setBorder(BorderFactory.createTitledBorder("Bind DAP with DBMS"));
		((javax.swing.border.TitledBorder) dbmsdappanel.getBorder()).setTitleFont(new Font("Arial", Font.BOLD, 14));
		JPanel pbutton = new JPanel(new FlowLayout(FlowLayout.LEFT));
		pbutton.add(btDBMSBinding);
		dbmsdappanel.add(pbutton, BorderLayout.NORTH);
		bindinglistpanel.setLayout(new BoxLayout(bindinglistpanel, BoxLayout.Y_AXIS));
		DBMSSelectionPanel bindingpanel = new DBMSSelectionPanel(z3analyzer);
		bindinglist.add(bindingpanel);
		bindinglistpanel.add(bindingpanel);
		dbmsdappanel.add(bindinglistpanel, BorderLayout.CENTER);
		JPanel pbutton2 = new JPanel(new FlowLayout(FlowLayout.LEFT));
		pbutton2.add(btLoadDBMSBinding);
		dbmsdappanel.add(pbutton2, BorderLayout.SOUTH);
		this.add(dbmsdappanel);


		interdappanel.setLayout(new BorderLayout());
		interdappanel.setBorder(BorderFactory.createTitledBorder("Dependency between DAP"));
		((javax.swing.border.TitledBorder) interdappanel.getBorder()).setTitleFont(new Font("Arial", Font.BOLD, 14));
		JPanel pbutton3 = new JPanel(new FlowLayout(FlowLayout.LEFT));
		pbutton3.add(btDAPBinding);
		interdappanel.add(pbutton3, BorderLayout.NORTH);
		dapdependencylistpanel.setLayout(new BoxLayout(dapdependencylistpanel, BoxLayout.Y_AXIS));
		InterDAPDependencyPanel_deprecated dapdependpanel = new InterDAPDependencyPanel_deprecated(z3analyzer);
		dapdependencylist.add(dapdependpanel);
		dapdependencylistpanel.add(dapdependpanel);
		interdappanel.add(dapdependencylistpanel, BorderLayout.CENTER);
		JPanel pbutton4 = new JPanel(new FlowLayout(FlowLayout.LEFT));
		pbutton4.add(btLoadDAPBinding);
		interdappanel.add(pbutton4, BorderLayout.SOUTH);
		this.add(interdappanel);
	}

	void implementRules() {
		btDBMSBinding.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				addNewDBMSBiding();
			}
		});
		
		btDAPBinding.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				addNewInterDAPBiding();
			}
		});
	}
	
	public void addNewDBMSBiding() {
		DBMSSelectionPanel bindingpanel = new DBMSSelectionPanel(z3analyzer);
		bindinglist.add(bindingpanel);
		bindinglistpanel.add(bindingpanel);
		bindinglistpanel.revalidate();
		bindinglistpanel.repaint();
	}

	public void addNewInterDAPBiding() {
		InterDAPDependencyPanel_deprecated bindingpanel = new InterDAPDependencyPanel_deprecated(z3analyzer);
		dapdependencylist.add(bindingpanel);
		dapdependencylistpanel.add(bindingpanel);
		dapdependencylistpanel.revalidate();
		dapdependencylistpanel.repaint();
	}
}
