package aggtool.ui;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;

import aggtool.metadata.DAPSpec;
import aggtool.metadata.DAPSpecList;
import aggtool.metadata.DBMSSpecList;
import aggtool.metadata.RDTypeSpec;
import aggtool.metadata.RawDataSpec;
import aggtool.z3.Z3Analyzer;

public class InterDAPDependencyPanel extends JPanel {
	
	Z3Analyzer z3analyzer;
	public JComboBox cbDAPAggData = new JComboBox();
	public JComboBox cbDependentDAP = new JComboBox();
	public JComboBox cbDependentDAPRDType = new JComboBox();
	public JComboBox cbDependentDAPRawData = new JComboBox();
	//DAPSpecList alternativeDAPs = new DAPSpecList();
	DAPSpecList alternative = new DAPSpecList();
	DefaultComboBoxModel alternativeDAPs = new DefaultComboBoxModel();
	DefaultComboBoxModel alternativeRDTs = new DefaultComboBoxModel();
	DefaultComboBoxModel alternativeRDs = new DefaultComboBoxModel();
	
	public InterDAPDependencyPanel(Z3Analyzer z) {
		super();

		z3analyzer = z;
		initialize();
		implementRules();
		
	}
	
	void initialize() {
		this.setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
		this.setBorder(BorderFactory.createLoweredBevelBorder());
		JPanel panel1 = new JPanel(new FlowLayout(FlowLayout.LEFT));
		JLabel laggdata = new JLabel("The aggregated data of DAP ");
		panel1.add(laggdata);
		this.add(panel1);
		JPanel panel2 = new JPanel(new FlowLayout(FlowLayout.LEFT));
		alternative.copy(z3analyzer.DAPList);
		cbDAPAggData.setModel(alternative);
		cbDAPAggData.setPrototypeDisplayValue("Data Aggregation Process");
		panel2.add(cbDAPAggData);
		this.add(panel2);
		JPanel panel3 = new JPanel(new FlowLayout(FlowLayout.LEFT));
		JLabel lrawdata = new JLabel("is used as the raw data of DAP");
		panel3.add(lrawdata);
		this.add(panel3);
		JPanel deppanel = new JPanel(new FlowLayout(FlowLayout.LEFT));
		cbDependentDAP.setModel(alternativeDAPs);
		cbDependentDAP.setPrototypeDisplayValue("Data Aggregation Process");
		deppanel.add(cbDependentDAP);
		cbDependentDAPRDType.setModel(alternativeRDTs);
		cbDependentDAPRDType.setPrototypeDisplayValue("Raw Data Type");
		deppanel.add(cbDependentDAPRDType);
		cbDependentDAPRawData.setModel(alternativeRDs);
		cbDependentDAPRawData.setPrototypeDisplayValue("Raw Data A");
		deppanel.add(cbDependentDAPRawData);
		this.add(deppanel);
		JPanel panel4 = new JPanel(new FlowLayout(FlowLayout.LEFT));
		JLabel lexplain = new JLabel("(Only feasible DAP and data are listed and selectable)");
		//panel4.add(lexplain);
		this.add(panel4);
	}
	

	void implementRules() {
		
		cbDAPAggData.addMouseListener(new MouseListener () {

			@Override
			public void mouseClicked(MouseEvent arg0) {
				// TODO Auto-generated method stub
				alternative.copy(z3analyzer.DAPList);
			}

			@Override
			public void mouseEntered(MouseEvent arg0) {
				// TODO Auto-generated method stub
				
			}

			@Override
			public void mouseExited(MouseEvent arg0) {
				// TODO Auto-generated method stub
				
			}

			@Override
			public void mousePressed(MouseEvent arg0) {
				// TODO Auto-generated method stub
				
			}

			@Override
			public void mouseReleased(MouseEvent arg0) {
				// TODO Auto-generated method stub
				
			}
		});
		
		cbDAPAggData.addItemListener(new ItemListener() {

			@Override
			public void itemStateChanged(ItemEvent arg0) {
				DAPSpec dap = (DAPSpec) cbDAPAggData.getSelectedItem();
				alternativeDAPs.removeAllElements();
				alternativeRDTs.removeAllElements();
				alternativeRDs.removeAllElements();
				for(DAPSpec dapspec : z3analyzer.DAPList.DAPSpecList) {
					if(!(dapspec.name.equals(dap.name))) {
						alternativeDAPs.addElement(dapspec.name);
					}
				}		
			}
		});
		
		cbDependentDAP.addItemListener(new ItemListener() {

			@Override
			public void itemStateChanged(ItemEvent arg0) {
				String dapname = (String) cbDependentDAP.getSelectedItem();
				alternativeRDTs.removeAllElements();
				alternativeRDs.removeAllElements();
				for(DAPSpec dapspec : z3analyzer.DAPList.DAPSpecList) {
					if(dapspec.name.equals(dapname)) {
						for(RDTypeSpec rdt : dapspec.rawdatatypelist) {
							alternativeRDTs.addElement(rdt.name);
						}
					}
				}		
			}
		});
		
		cbDependentDAPRDType.addItemListener(new ItemListener() {

			@Override
			public void itemStateChanged(ItemEvent arg0) {
				String dapname = (String) cbDependentDAP.getSelectedItem();
				String rdtname = (String) cbDependentDAPRDType.getSelectedItem();
				alternativeRDs.removeAllElements();
				for(DAPSpec dapspec : z3analyzer.DAPList.DAPSpecList) {
					if(dapspec.name.equals(dapname)) {
						for(RDTypeSpec rdt : dapspec.rawdatatypelist) {
							if(rdt.name.equals(rdtname)) {
								for(RawDataSpec rd : rdt.rawdatalist) {

									alternativeRDs.addElement(rd.name);
								}
							}
						}
					}
				}		
			}
		});
	}
}
