package aggtool.ui;

import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BoxLayout;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;

import aggtool.metadata.DAPSpec;
import aggtool.metadata.DAPSpecList;
import aggtool.metadata.DBMSSpecList;
import aggtool.metadata.RDTypeSpec;
import aggtool.metadata.RawDataSpec;
import aggtool.z3.Z3Analyzer;

public class InterDAPDependencyPanel_deprecated extends JPanel {
	
	Z3Analyzer z3analyzer;
	JComboBox cbDAPAggData = new JComboBox();
	JComboBox cbDependentDAP = new JComboBox();
	JComboBox cbDependentDAPRDType = new JComboBox();
	JComboBox cbDependentDAPRawData = new JComboBox();
	//DAPSpecList alternativeDAPs = new DAPSpecList();
	DefaultComboBoxModel alternativeDAPs = new DefaultComboBoxModel();
	DefaultComboBoxModel alternativeRDTs = new DefaultComboBoxModel();
	DefaultComboBoxModel alternativeRDs = new DefaultComboBoxModel();
	
	public InterDAPDependencyPanel_deprecated(Z3Analyzer z) {
		super();

		z3analyzer = z;
		initialize();
		implementRules();
		
	}
	
	void initialize() {
		this.setLayout(new FlowLayout());
		JLabel laggdata = new JLabel("The aggregated data of DAP ");
		this.add(laggdata);
		cbDAPAggData.setModel(z3analyzer.DAPList);
		cbDAPAggData.setPrototypeDisplayValue("Data Aggregation Process");
		this.add(cbDAPAggData);
		JLabel lrawdata = new JLabel("is used as the raw data of DAP");
		this.add(lrawdata);
		cbDependentDAP.setModel(alternativeDAPs);
		cbDependentDAP.setPrototypeDisplayValue("Data Aggregation Process");
		this.add(cbDependentDAP);
		cbDependentDAPRDType.setModel(alternativeRDTs);
		cbDependentDAPRDType.setPrototypeDisplayValue("Raw Data Type");
		this.add(cbDependentDAPRDType);
		cbDependentDAPRawData.setModel(alternativeRDs);
		cbDependentDAPRawData.setPrototypeDisplayValue("Raw Data A");
		this.add(cbDependentDAPRawData);
	}
	

	void implementRules() {
		cbDAPAggData.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				DAPSpec dap = (DAPSpec) cbDAPAggData.getSelectedItem();
				alternativeDAPs.removeAllElements();
				alternativeRDTs.removeAllElements();
				alternativeRDs.removeAllElements();
				for(DAPSpec dapspec : z3analyzer.DAPList.DAPSpecList) {
					if(!(dapspec.name.equals(dap.name))) {
						alternativeDAPs.addElement(dapspec.name);
					}
				}		
			}
		});
		
		cbDependentDAP.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				String dapname = (String) cbDependentDAP.getSelectedItem();
				alternativeRDTs.removeAllElements();
				alternativeRDs.removeAllElements();
				for(DAPSpec dapspec : z3analyzer.DAPList.DAPSpecList) {
					if(dapspec.name.equals(dapname)) {
						for(RDTypeSpec rdt : dapspec.rawdatatypelist) {
							alternativeRDTs.addElement(rdt.name);
						}
					}
				}		
			}
		});
		
		cbDependentDAPRDType.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				String dapname = (String) cbDependentDAP.getSelectedItem();
				String rdtname = (String) cbDependentDAPRDType.getSelectedItem();
				alternativeRDs.removeAllElements();
				for(DAPSpec dapspec : z3analyzer.DAPList.DAPSpecList) {
					if(dapspec.name.equals(dapname)) {
						for(RDTypeSpec rdt : dapspec.rawdatatypelist) {
							if(rdt.name.equals(rdtname)) {
								for(RawDataSpec rd : rdt.rawdatalist) {

									alternativeRDs.addElement(rd.name);
								}
							}
						}
					}
				}		
			}
		});
	}
}
