package aggtool.ui;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.util.ArrayList;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JScrollPane;

import com.microsoft.z3.BoolExpr;

import aggtool.z3.Z3Analyzer;

public class InterDAPDepenencyUpperPanel extends JPanel {
	public Z3Analyzer z3analyzer;

	public JButton btDAPBinding = new JButton("New Inter-DAP Dependency");
	public JButton btClear = new JButton("Clear All Dependencies");
	public JButton btLoadDAPBinding = new JButton("Load All Inter-DAP Dependencies");
	public ArrayList<InterDAPDependencyPanel> dapdependencylist = new ArrayList<InterDAPDependencyPanel>();
	public JPanel dapdependencylistpanel = new JPanel();
	public JPanel interdappanel = new JPanel();
	
	public InterDAPDepenencyUpperPanel(Z3Analyzer z) {
		super();
		z3analyzer = z;
		initialize();
		implementRules();
	}
	
	void initialize() {
		//DBMSSelectionPanel
		this.setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
		
		


		interdappanel.setLayout(new BorderLayout());
		interdappanel.setBorder(BorderFactory.createTitledBorder("Dependency between DAP"));
		((javax.swing.border.TitledBorder) interdappanel.getBorder()).setTitleFont(new Font("Arial", Font.BOLD, 14));
		JPanel pbutton3 = new JPanel(new FlowLayout(FlowLayout.LEFT));
		pbutton3.add(btDAPBinding);
		pbutton3.add(btClear);
		interdappanel.add(pbutton3, BorderLayout.NORTH);
		dapdependencylistpanel.setLayout(new BoxLayout(dapdependencylistpanel, BoxLayout.Y_AXIS));
		//InterDAPDependencyPanel dapdependpanel = new InterDAPDependencyPanel(z3analyzer);
		//dapdependencylist.add(dapdependpanel);
		//dapdependencylistpanel.add(dapdependpanel);
		JScrollPane scrollPane = new JScrollPane(dapdependencylistpanel);
		interdappanel.add(scrollPane, BorderLayout.CENTER);
		JPanel pbutton4 = new JPanel(new FlowLayout(FlowLayout.LEFT));
		pbutton4.add(btLoadDAPBinding);
		interdappanel.add(pbutton4, BorderLayout.SOUTH);
		
		this.add(interdappanel);
	}

	void implementRules() {
		
		
		btDAPBinding.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				addNewInterDAPBiding();
			}
		});
		
		btClear.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				clearAll();
			}
		});
		
		btLoadDAPBinding.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				z3analyzer.InterDAPConstraints.clear();
				z3analyzer.addInterDAPRules(dapdependencylist);
				for(BoolExpr f : z3analyzer.InterDAPConstraints) {
					System.out.println(f.toString());
				}
			}
		});
	}
	
	public void clearAll() {
		z3analyzer.InterDAPConstraints.clear();
		dapdependencylist.clear();
		dapdependencylistpanel.removeAll();
		InterDAPDependencyPanel dapdependpanel = new InterDAPDependencyPanel(z3analyzer);
		dapdependencylist.add(dapdependpanel);
		dapdependencylistpanel.add(dapdependpanel);

		this.revalidate();
		this.repaint();
	}

	public void addNewInterDAPBiding() {
		InterDAPDependencyPanel bindingpanel = new InterDAPDependencyPanel(z3analyzer);
		dapdependencylist.add(bindingpanel);
		dapdependencylistpanel.add(bindingpanel);
		dapdependencylistpanel.revalidate();
		dapdependencylistpanel.repaint();
	}
}
