package aggtool.ui;

import java.awt.Component;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

public class RDTypePanel extends JPanel {
	public ArrayList<RawDataPanel> rdpanels = new ArrayList<RawDataPanel>();
	public JTextField txtName = new JTextField();
	public JTextField txtMinCard = new JTextField();
	public JTextField txtMaxCard = new JTextField();
	public JPanel rdlistpanel =  new JPanel(new FlowLayout());
	public JButton btAddRD = new JButton("New Raw Data");
	
	public RDTypePanel() {
		super();

		initialize();
		
	}
	
	void initialize() {

		this.setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
		this.setBorder(BorderFactory.createTitledBorder("Raw Data Type"));
		((javax.swing.border.TitledBorder) this.getBorder()).setTitleFont(new Font("Arial", Font.BOLD, 14));

		JPanel pName = new JPanel(new FlowLayout(FlowLayout.LEFT));
		pName.add(new JLabel("Raw Data Type Name: "));
		txtName.setPreferredSize(new Dimension(100, 20));
		pName.add(txtName);
		
		this.add(pName);
		
		JPanel pCard = new JPanel(new FlowLayout(FlowLayout.LEFT));
		pCard.add(new JLabel("Cardinality Min: "));
		txtMinCard.setPreferredSize(new Dimension(30, 20));
		pCard.add(txtMinCard);
		pCard.add(new JLabel("Max: "));
		txtMaxCard.setPreferredSize(new Dimension(30, 20));
		pCard.add(txtMaxCard);
		
		//this.add(pCard);
		

		JPanel pbutton = new JPanel(new FlowLayout(FlowLayout.LEFT));
		pbutton.add(btAddRD);
		this.add(pbutton);
		
		RawDataPanel rdpanel1 = new RawDataPanel();
		rdpanel1.txtName.setText("RD"+(rdpanels.size()+1));
		rdpanels.add(rdpanel1);
		rdlistpanel.add(rdpanel1);
		

		this.add(rdlistpanel);
		
		implementRules();
	}
	
	void implementRules() {
		btAddRD.addActionListener(new ActionListener()
		{
			  public void actionPerformed(ActionEvent e)
			  {
			    // display/center the jdialog when the button is pressed
				  addNewRawData();
			  }
			});
	}
	
	public void addNewRawData() {
		RawDataPanel rdpanel = new RawDataPanel();
		rdpanel.txtName.setText("RD"+(rdpanels.size()+1));
		rdpanels.add(rdpanel);
		rdlistpanel.add(rdpanel);
		rdlistpanel.revalidate();
		rdlistpanel.repaint();
	}
}
