package aggtool.ui;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.ImageIcon;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;
import javax.swing.border.EmptyBorder;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

public class RawDataPanel extends JPanel {
	public JCheckBox cbPull = new JCheckBox("Pull");
	public JCheckBox cbPersistent = new JCheckBox("Persistent");
	public JCheckBox cbShared = new JCheckBox("Shared");
	public JCheckBox cbMINT = new JCheckBox("MINT");
	public JCheckBox cbMAXT = new JCheckBox("MAXT");
	public JCheckBox cbSheddable = new JCheckBox("Sheddable");
	public JCheckBox cbRT = new JCheckBox("RealTime");
	public JCheckBox cbAVI = new JCheckBox("AVI");
	public JTextField txtName = new JTextField();
	public JTextField txtMinCard = new JTextField();
	public JTextField txtMaxCard = new JTextField();
	
	public ButtonGroup groupHardFirmSoft = new ButtonGroup();
	public JRadioButton rbHard = new JRadioButton("Hard");
	public JRadioButton rbFirm = new JRadioButton("Firm");
	public JRadioButton rbSoft = new JRadioButton("Soft");
	public ImageIcon tipIcon = new ImageIcon("rsc/exclamation.png");

	JLabel lPullTip = new JLabel();
	JLabel lPersTip = new JLabel();
	JLabel lSharedTip = new JLabel();
	JLabel lSheddableTip = new JLabel();
	
	
	public RawDataPanel() {
		super();

		initialize();
		
	}
	
	void initialize() {
		this.setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
		this.setBorder(BorderFactory.createTitledBorder("Raw Data"));
		((javax.swing.border.TitledBorder) this.getBorder()).setTitleFont(new Font("Arial", Font.BOLD, 12));

		JPanel pName = new JPanel(new FlowLayout(FlowLayout.LEFT));
		pName.add(new JLabel("Raw Data Name: "));
		txtName.setPreferredSize(new Dimension(100, 20));
		pName.add(txtName);
		
		this.add(pName);
		

		JPanel pCard = new JPanel(new FlowLayout(FlowLayout.LEFT));
		pCard.add(new JLabel("Cardinality Min: "));
		txtMinCard.setPreferredSize(new Dimension(30, 20));
		pCard.add(txtMinCard);
		pCard.add(new JLabel("Max: "));
		txtMaxCard.setPreferredSize(new Dimension(30, 20));
		pCard.add(txtMaxCard);
		
		//this.add(pCard);
		
		JPanel pPull = new JPanel(new FlowLayout(FlowLayout.LEFT));
		//pPull.setBorder(new EmptyBorder (0, 5, 0, 0));
		pPull.add(cbPull);
		lPullTip.setIcon(tipIcon);
		lPullTip.setToolTipText("Consider to implement synchronization for the pulled data.");
		pPull.add(lPullTip);
		lPullTip.setVisible(false);
		this.add(pPull);
		
		JPanel pPersistent = new JPanel(new FlowLayout(FlowLayout.LEFT));
		pPersistent.setBorder(new EmptyBorder (0, 15, 0, 0));
		pPersistent.add(cbPersistent);
		
		lPersTip.setIcon(tipIcon);
		lPersTip.setToolTipText("Consider to use persistent storage for the persistent data.");
		pPersistent.add(lPersTip);
		lPersTip.setVisible(false);
		//this.add(cbPull);
		this.add(pPersistent);
		//pPersistent.setAlignmentX(Component.LEFT_ALIGNMENT);

		cbPersistent.setEnabled(false);
		

		JPanel pMINT = new JPanel(new FlowLayout(FlowLayout.LEFT));
		pMINT.add(cbMINT);
		this.add(pMINT);
		JPanel pMAXT = new JPanel(new FlowLayout(FlowLayout.LEFT));
		pMAXT.add(cbMAXT);
		this.add(pMAXT);
		
		JPanel pShared = new JPanel(new FlowLayout(FlowLayout.LEFT));
		//pShared.setBorder(new EmptyBorder (0, -66, 0, 0));
		pShared.add(cbShared);		
		lSharedTip.setIcon(tipIcon);
		lSharedTip.setToolTipText("Consider to use concurrency control for the shared data.");
		pShared.add(lSharedTip);
		lSharedTip.setVisible(false);
		//pShared.setAlignmentX(Component.LEFT_ALIGNMENT);
		//this.add(cbShared);
		this.add(pShared);
		
		JPanel pSheddable = new JPanel(new FlowLayout(FlowLayout.LEFT));
		pSheddable.add(cbSheddable);
		lSheddableTip.setIcon(tipIcon);
		lSheddableTip.setToolTipText("Consider to apply load shedding or approximation for the sheddable data.");
		pSheddable.add(lSheddableTip);
		lSheddableTip.setVisible(false);
		this.add(pSheddable);

		JPanel pRT = new JPanel(new FlowLayout(FlowLayout.LEFT));
		pRT.add(cbRT);
		this.add(pRT);
		
		JPanel pAVI = new JPanel(new FlowLayout(FlowLayout.LEFT));
		//pAVI.add(new JLabel("     "));
		pAVI.setBorder(new EmptyBorder (0, 15, 0, 0));
		pAVI.setName("RealTime");
		pAVI.add(cbAVI);
		this.add(pAVI);

		//pAVI.setAlignmentX(Component.LEFT_ALIGNMENT);

		groupHardFirmSoft.add(rbHard);
		groupHardFirmSoft.add(rbFirm);
		groupHardFirmSoft.add(rbSoft);
		JPanel pGroup = new JPanel();
		pGroup.setName("RealTime");
		pGroup.setLayout(new BoxLayout(pGroup, BoxLayout.Y_AXIS));
		pGroup.add(rbHard);
		pGroup.add(rbFirm);
		pGroup.add(rbSoft);
		

		cbAVI.setEnabled(false);
		rbHard.setEnabled(false);
		rbHard.setSelected(true);
		rbFirm.setEnabled(false);
		rbSoft.setEnabled(false);
		
		JPanel pGroupUpper = new JPanel(new FlowLayout(FlowLayout.LEFT));
		pGroupUpper.setBorder(new EmptyBorder (0, 15, 0, 0));
		pGroupUpper.add(pGroup);
		//pGroupUpper.setAlignmentX(Component.LEFT_ALIGNMENT);
		this.add(pGroupUpper);
		
		
		implementRules();
	}
	
	void implementRules() {
		cbPull.addItemListener(new ItemListener() {

		    public void itemStateChanged(ItemEvent e) {
		    	if(e.getStateChange() == ItemEvent.DESELECTED) {
		    		lPullTip.setVisible(false);
		    		cbPersistent.setSelected(false);
		    		cbPersistent.setEnabled(false);
		    	} else {

		    		lPullTip.setVisible(true);
		    		cbPersistent.setEnabled(true);
		    	}
		    }
		});
		
		cbPersistent.addItemListener(new ItemListener() {

		    public void itemStateChanged(ItemEvent e) {
		    	if(e.getStateChange() == ItemEvent.DESELECTED) {
		    		lPersTip.setVisible(false);
		    	} else {

		    		lPersTip.setVisible(true);
		    	}
		    }
		});

		cbShared.addItemListener(new ItemListener() {

		    public void itemStateChanged(ItemEvent e) {
		    	if(e.getStateChange() == ItemEvent.DESELECTED) {
		    		lSharedTip.setVisible(false);
		    	} else {

		    		lSharedTip.setVisible(true);
		    	}
		    }
		});
		
		cbSheddable.addItemListener(new ItemListener() {

		    public void itemStateChanged(ItemEvent e) {
		    	if(e.getStateChange() == ItemEvent.DESELECTED) {
		    		lSheddableTip.setVisible(false);
		    	} else {

		    		lSheddableTip.setVisible(true);
		    	}
		    }
		});
		

		cbRT.addItemListener(new ItemListener() {

		    public void itemStateChanged(ItemEvent e) {
		    	if(e.getStateChange() == ItemEvent.DESELECTED) {
		    		cbAVI.setSelected(false);
		    		cbAVI.setEnabled(false);
		    		rbHard.setSelected(false);
		    		rbHard.setEnabled(false);
		    		rbFirm.setSelected(false);
		    		rbFirm.setEnabled(false);
		    		rbSoft.setSelected(false);
		    		rbSoft.setEnabled(false);
		    	} else {
		    		cbAVI.setEnabled(true);
		    		cbAVI.setSelected(true);
		    		rbHard.setEnabled(true);
		    		rbFirm.setEnabled(true);
		    		rbSoft.setEnabled(true);
		    	}
		    }
		});
		
		cbAVI.addItemListener(new ItemListener() {

		    public void itemStateChanged(ItemEvent e) {
		    	if(e.getStateChange() == ItemEvent.DESELECTED) {
		    		cbRT.setSelected(false);
		    	} else {

		    		cbRT.setSelected(true);
		    	}
		    }
		});
	}
}
