package aggtool.ui;

import java.awt.Component;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.JCheckBox;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;
import javax.swing.border.EmptyBorder;

public class RealTimeProcessPanel extends JPanel {
	public JCheckBox cbRTPEnable = new JCheckBox("Select Real Time Process");
	public JCheckBox cbDeadline = new JCheckBox("Deadline");
	public JPanel pInner = new JPanel();
	
	public ButtonGroup groupHardFirmSoft = new ButtonGroup();
	public JRadioButton rbHard = new JRadioButton("Hard");
	public JRadioButton rbFirm = new JRadioButton("Firm");
	public JRadioButton rbSoft = new JRadioButton("Soft");
	
	public RealTimeProcessPanel() {
		super();

		initialize();
		
	}
	
	void initialize() {

		this.setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
		this.add(cbRTPEnable);
		
		pInner.setLayout(new BoxLayout(pInner, BoxLayout.Y_AXIS));
		pInner.setBorder(BorderFactory.createTitledBorder("Real Time Process"));
		((javax.swing.border.TitledBorder) pInner.getBorder()).setTitleFont(new Font("Arial", Font.BOLD, 14));
		
		pInner.add(cbDeadline);
		
		groupHardFirmSoft.add(rbHard);
		groupHardFirmSoft.add(rbFirm);
		groupHardFirmSoft.add(rbSoft);
		JPanel pGroup = new JPanel();
		pGroup.setLayout(new BoxLayout(pGroup, BoxLayout.Y_AXIS));
		pGroup.add(rbHard);
		pGroup.add(rbFirm);
		pGroup.add(rbSoft);

		JPanel pGroupUpper = new JPanel(new FlowLayout());
		pGroupUpper.add(pGroup);
		pGroupUpper.setBorder(BorderFactory.createTitledBorder(""));
		pGroupUpper.setAlignmentX(Component.LEFT_ALIGNMENT);
		pInner.add(pGroupUpper);
		

		cbDeadline.setSelected(false);
		cbDeadline.setEnabled(false);
		rbHard.setSelected(true);
		rbHard.setEnabled(false);
		rbFirm.setSelected(false);
		rbFirm.setEnabled(false);
		rbSoft.setSelected(false);
		rbSoft.setEnabled(false);
		
		this.add(pInner);
		implementRules();
	}
	
	void implementRules() {
		

		cbRTPEnable.addItemListener(new ItemListener() {

		    public void itemStateChanged(ItemEvent e) {
		    	if(e.getStateChange() == ItemEvent.DESELECTED) {
		    		cbDeadline.setSelected(false);
		    		cbDeadline.setEnabled(false);
		    		rbHard.setSelected(false);
		    		rbHard.setEnabled(false);
		    		rbFirm.setSelected(false);
		    		rbFirm.setEnabled(false);
		    		rbSoft.setSelected(false);
		    		rbSoft.setEnabled(false);
		    	} else {
		    		cbDeadline.setSelected(true);
		    		cbDeadline.setEnabled(true);
		    		rbHard.setEnabled(true);
		    		rbFirm.setEnabled(true);
		    		rbSoft.setEnabled(true);
		    	}
		    }
		});
		
		cbDeadline.addItemListener(new ItemListener() {

		    public void itemStateChanged(ItemEvent e) {
		    	if(e.getStateChange() == ItemEvent.DESELECTED) {
		    		cbRTPEnable.setSelected(false);
		    	} else {
		    		cbRTPEnable.setSelected(true);
		    	}
		    }
		});
	}
}
