package aggtool.ui;

import java.awt.Component;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.JCheckBox;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.border.EmptyBorder;

public class TriggeringPatternPanel extends JPanel {
	public JCheckBox cbEvents = new JCheckBox("Events");
	public JCheckBox cbPeriod = new JCheckBox("Period");
	
	public ButtonGroup groupTP = new ButtonGroup();
	public JRadioButton rbAperiodic = new JRadioButton("Aperiodic");
	public JRadioButton rbPeriodic = new JRadioButton("Periodic");
	public JRadioButton rbSporadic = new JRadioButton("Sporadic");
	

	public ButtonGroup groupSporadic = new ButtonGroup();
	public JRadioButton rbEvents = new JRadioButton("Events");
	public JRadioButton rbMINT = new JRadioButton("MINT");
	public JRadioButton rbMAXT = new JRadioButton("MAXT");
	
	public TriggeringPatternPanel() {
		super();

		initialize();
		
	}
	
	void initialize() {

		this.setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
		this.setBorder(BorderFactory.createTitledBorder("Triggering Pattern"));
		this.setPreferredSize(new Dimension(200, 300));
		((javax.swing.border.TitledBorder) this.getBorder()).setTitleFont(new Font("Arial", Font.BOLD, 14));
		
		groupTP.add(rbAperiodic);
		groupTP.add(rbPeriodic);
		groupTP.add(rbSporadic);
		
		groupSporadic.add(rbEvents);
		groupSporadic.add(rbMINT);
		groupSporadic.add(rbMAXT);
		
		JPanel pEvent = new JPanel(new FlowLayout());
		pEvent.setName("Aperiodic");
		pEvent.setBorder(new EmptyBorder (0, 5, 0, 0));
		pEvent.add(cbEvents);
		JPanel pAperiodic = new JPanel();
		pAperiodic.setLayout(new BoxLayout(pAperiodic, BoxLayout.Y_AXIS));
		pAperiodic.add(rbAperiodic);
		pAperiodic.add(pEvent);
		pEvent.setAlignmentX(Component.LEFT_ALIGNMENT);
		

		JPanel pPeriod = new JPanel(new FlowLayout());
		pPeriod.setBorder(new EmptyBorder (0, 5, 0, 0));
		pPeriod.add(cbPeriod);
		pPeriod.setName("Periodic");
		JPanel pPeriodic = new JPanel();
		pPeriodic.setLayout(new BoxLayout(pPeriodic, BoxLayout.Y_AXIS));
		pPeriodic.add(rbPeriodic);
		pPeriodic.add(pPeriod);
		pPeriod.setAlignmentX(Component.LEFT_ALIGNMENT);
		
		
		JPanel pSporadicInner = new JPanel();
		pSporadicInner.setName("Sporadic");
		pSporadicInner.setLayout(new BoxLayout(pSporadicInner, BoxLayout.Y_AXIS));
		pSporadicInner.add(rbEvents);
		pSporadicInner.add(rbMINT);
		pSporadicInner.add(rbMAXT);
		JPanel pSporadicUpper = new JPanel(new FlowLayout());
		pSporadicUpper.setBorder(new EmptyBorder (0, 5, 0, 0));
		pSporadicUpper.add(pSporadicInner);
		pSporadicUpper.setBorder(BorderFactory.createTitledBorder(""));
		pSporadicUpper.setAlignmentX(Component.LEFT_ALIGNMENT);
		JPanel pSporadic = new JPanel();
		pSporadic.setLayout(new BoxLayout(pSporadic, BoxLayout.Y_AXIS));
		pSporadic.add(rbSporadic);
		pSporadic.add(pSporadicUpper);
		

		JPanel pGroupTP = new JPanel();
		pGroupTP.setLayout(new BoxLayout(pGroupTP, BoxLayout.Y_AXIS));
		pGroupTP.add(pAperiodic);
		pGroupTP.add(pPeriodic);
		pGroupTP.add(pSporadic);
		this.add(pGroupTP);
		

		cbEvents.setSelected(true);
		cbEvents.setEnabled(true);
		cbPeriod.setSelected(false);
		cbPeriod.setEnabled(false);
		rbEvents.setSelected(true);
		rbEvents.setEnabled(false);
		rbMINT.setSelected(false);
		rbMINT.setEnabled(false);
		rbMAXT.setSelected(false);
		rbMAXT.setEnabled(false);
		
		rbAperiodic.setSelected(true);
		implementRules();
	}
	
	
	void implementRules() {
		rbAperiodic.addItemListener(new ItemListener() {

		    public void itemStateChanged(ItemEvent e) {
		    	if(e.getStateChange() == ItemEvent.DESELECTED) {
		    		cbEvents.setSelected(false);
		    		cbEvents.setEnabled(false);
		    	} else {

		    		cbEvents.setEnabled(true);
		    		cbEvents.setSelected(true);
		    	}
		    }
		});
		
		cbEvents.addItemListener(new ItemListener() {

		    public void itemStateChanged(ItemEvent e) {
		    	if(e.getStateChange() == ItemEvent.DESELECTED) {
		    		rbAperiodic.setSelected(false);
		    		rbSporadic.setSelected(true);
		    	} else {

		    		rbAperiodic.setSelected(true);
		    	}
		    }
		});
		
		rbPeriodic.addItemListener(new ItemListener() {

		    public void itemStateChanged(ItemEvent e) {
		    	if(e.getStateChange() == ItemEvent.DESELECTED) {
		    		cbPeriod.setSelected(false);
		    		cbPeriod.setEnabled(false);
		    	} else {

		    		cbPeriod.setEnabled(true);
		    		cbPeriod.setSelected(true);
		    	}
		    }
		});
		
		cbPeriod.addItemListener(new ItemListener() {

		    public void itemStateChanged(ItemEvent e) {
		    	if(e.getStateChange() == ItemEvent.DESELECTED) {
		    		rbPeriodic.setSelected(false);
		    		rbSporadic.setSelected(true);
		    	} else {

		    		rbPeriodic.setSelected(true);
		    	}
		    }
		});
		

		rbSporadic.addItemListener(new ItemListener() {

		    public void itemStateChanged(ItemEvent e) {
		    	if(e.getStateChange() == ItemEvent.DESELECTED) {
		    		rbEvents.setSelected(false);
		    		rbEvents.setEnabled(false);
		    		rbMINT.setSelected(false);
		    		rbMINT.setEnabled(false);
		    		rbMAXT.setSelected(false);
		    		rbMAXT.setEnabled(false);
		    	} else {
		    		rbEvents.setEnabled(true);
		    		rbMINT.setEnabled(true);
		    		rbMAXT.setEnabled(true);
		    	}
		    }
		});
	}
}
