package aggtool.ui_old;

import java.awt.Component;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.MouseEvent;
import java.util.ArrayList;
import java.util.EventObject;

import javax.swing.AbstractCellEditor;
import javax.swing.JCheckBox;
import javax.swing.JTree;
import javax.swing.event.ChangeEvent;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.TreeCellEditor;
import javax.swing.tree.TreePath;

import aggtool.metadata.AggNode;

class CustomizedTreeCellEditor extends AbstractCellEditor implements TreeCellEditor {

	CustomizedTreeRenderer renderer = new CustomizedTreeRenderer();

	  ChangeEvent changeEvent = null;

	  JTree tree;

	  public CustomizedTreeCellEditor(JTree tree) {
	    this.tree = tree;
	  }

	  public Object getCellEditorValue() {
	    JCheckBox checkbox = renderer.getCheckBoxRenderer();
	    CustomizedNode node = new CustomizedNode(checkbox.getText());
	    return node;
	  }

	  public boolean isCellEditable(EventObject event) {
	    boolean returnValue = false;
	    if (event instanceof MouseEvent) {
	      MouseEvent mouseEvent = (MouseEvent) event;
	      TreePath path = tree.getPathForLocation(mouseEvent.getX(),
	          mouseEvent.getY());
	      if (path != null) {
	        Object node = path.getLastPathComponent();
	        if ((node != null) && (node instanceof CustomizedNode)) {
	        	CustomizedNode treeNode = (CustomizedNode) node;
	          if(treeNode.isMandatory || treeNode.isGroup) 
	        	  return false;
	          else
	        	  return true;
	          //Object userObject = treeNode.getUserObject();
	          //returnValue = ((treeNode.isLeaf()) && (userObject instanceof CustomizedNode));
	        }
	      }
	    }
	    return returnValue;
	  }

	  public Component getTreeCellEditorComponent(JTree tree, Object value,
	      boolean selected, boolean expanded, boolean leaf, int row) {

	    Component editor = renderer.getTreeCellRendererComponent(tree, value,
	        true, expanded, leaf, row, true);

	    MemberNode node;
		if (value != null && value instanceof MemberNode) {
			node = (MemberNode) value;

			NewItemListner listener = new NewItemListner(node);

			if (editor instanceof JCheckBox) {
				((JCheckBox) editor).addItemListener(listener);
			}

		}

	    return editor;
	  }
	  
	  private class NewItemListner implements ItemListener {
		public MemberNode node;
		public NewItemListner(MemberNode n) {
			node = n;
		}
		@Override
		public void itemStateChanged(ItemEvent e) {
			// TODO Auto-generated method stub
			Object obj = e.getSource();
	    	  if(obj != null && obj instanceof JCheckBox) {
	    		  JCheckBox checkbox = (JCheckBox) obj;
	    		  if(node != null) {
	    			  if(checkbox.isSelected()) {
	    				  ArrayList<CustomizedNode> siblings = node.group.members;
		    			  for(CustomizedNode sibling : siblings) {
		    				  if(!(sibling.name.equals(node.name))) {
		    					  sibling.isDisabled = true;
		    				  }
		    			  }
	    			  } else {
	    				  ArrayList<CustomizedNode> siblings = node.group.members;
		    			  for(CustomizedNode sibling : siblings) {
		    				  if(!(sibling.name.equals(node.name))) {
		    					  sibling.isDisabled = false;
		    				  }
		    			  }
	    			  }
	    			  
	    		  }
//	    		  if(checkbox.isSelected())
//	    			  checkbox.setSelected(false);
//	    		  else
//	    			  checkbox.setSelected(true);
	    	  }
//	        if (stopCellEditing()) {
//	          fireEditingStopped();
//	        }
	        
	      }
		}
		  
	  }
	