package aggtool.ui_old;

import java.awt.Color;
import java.awt.Component;
import java.awt.Font;
import java.awt.GridLayout;

import javax.swing.ButtonGroup;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTree;
import javax.swing.UIManager;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeCellRenderer;
import javax.swing.tree.TreeCellRenderer;
import javax.swing.tree.TreePath;

import aggtool.metadata.AggNode;

class CustomizedTreeRenderer implements TreeCellRenderer {
	  private JCheckBox checkBoxRenderer = new JCheckBox();
	  private JRadioButton radioButtonRenderer = new JRadioButton();
	  private JPanel buttonGroupRenderer = new JPanel();
	  private JLabel labelRenderer = new JLabel();

	  private DefaultTreeCellRenderer defaultRenderer = new DefaultTreeCellRenderer();

	  Color selectionBorderColor, selectionForeground, selectionBackground,
	      textForeground, textBackground;

	  protected JCheckBox getCheckBoxRenderer() {
	    return checkBoxRenderer;
	  }
	  
	  protected JLabel getLabelRenderer() {
		    return labelRenderer;
	  }

	  protected JRadioButton getRadioButtonRenderer() {
	    return radioButtonRenderer;
	  }
	  
	  protected JPanel getButtonGroupRenderer() {
		    return buttonGroupRenderer;
	  }

	  public CustomizedTreeRenderer() {
//	    Font fontValue;
//	    fontValue = UIManager.getFont("Tree.font");
//	    if (fontValue != null) {
//	      leafRenderer.setFont(fontValue);
//	    }
//	    Boolean booleanValue = (Boolean) UIManager
//	        .get("Tree.drawsFocusBorderAroundIcon");
//	    leafRenderer.setFocusPainted((booleanValue != null)
//	        && (booleanValue.booleanValue()));
//
	    selectionBorderColor = UIManager.getColor("Tree.selectionBorderColor");
	    selectionForeground = UIManager.getColor("Tree.selectionForeground");
	    selectionBackground = UIManager.getColor("Tree.selectionBackground");
	    textForeground = UIManager.getColor("Tree.textForeground");
	    textBackground = UIManager.getColor("Tree.textBackground");
	  }

	  public Component getTreeCellRendererComponent(JTree tree, Object value,
	      boolean selected, boolean expanded, boolean leaf, int row,
	      boolean hasFocus) {

	    Component returnValue;
	    if ((value != null) && (value instanceof CustomizedNode)) {
	        CustomizedNode node = (CustomizedNode) value;
//	        if(node.isGroup) {
//	        	GroupNode gnode = (GroupNode)node;
//	        	ButtonGroup buttongroup = new ButtonGroup();
//	        	JPanel radioPanel = new JPanel(new GridLayout(0, 1));
//	        	for(AggNode anode : gnode.members) {
//		        	JRadioButton radio = new JRadioButton(anode.name);
//		        	buttongroup.add(radio);
//		        	radioPanel.add(radio);
//	        	}
//	        	buttonGroupRenderer.add(radioPanel);
//	        	returnValue = radioPanel;
//		  	    return returnValue;
//	        } else if (leaf) {
	        
	        if(node.isDisabled)
	  	      checkBoxRenderer.setEnabled(false);
	        else
	        	checkBoxRenderer.setEnabled(true);
	        
	        if(node.isMandatory) {
	        	if (selected) {
	        		labelRenderer.setForeground(selectionForeground);
	        		labelRenderer.setBackground(selectionBackground);
		  	      } else {
		  	    	labelRenderer.setForeground(textForeground);
		  	    	labelRenderer.setBackground(textBackground);
		  	      }
	        	labelRenderer.setText(node.type);
	        	//return defaultRenderer.getTreeCellRendererComponent(tree, value, selected, expanded, leaf, row, hasFocus);
	        	return labelRenderer;
	        }

	  	      if (selected) {
	  	    	  checkBoxRenderer.setForeground(selectionForeground);
	  	    	  checkBoxRenderer.setBackground(selectionBackground);
	  	      } else {
	  	    	  checkBoxRenderer.setForeground(textForeground);
	  	    	  checkBoxRenderer.setBackground(textBackground);
	  	      }

	  	      //if ((value != null) && (value instanceof CustomizedNode)) {
	  	        Object userObject = ((DefaultMutableTreeNode) value)
	  	            .getUserObject();
	  	        //CustomizedNode node = (CustomizedNode) value;
	  	          checkBoxRenderer.setText(node.name);
	  	          //checkBoxRenderer.setSelected(node.isSelected());
	  	      //}
	  	        
	  	      TreePath path = tree.getPathForRow(row);   
	  	      if(tree.getSelectionModel().isPathSelected(path)) 
	  	    	checkBoxRenderer.setSelected(true); 
	          else 
	        	  checkBoxRenderer.setSelected(false);  
	  	      returnValue = checkBoxRenderer;
		  	    return returnValue;
	    }
//	  	    } else {
//	  	    	radioButtonRenderer.setEnabled(true);
//	  	    	//if ((value != null) && (value instanceof CustomizedNode)) {
//	  		        Object userObject = ((DefaultMutableTreeNode) value)
//	  		            .getUserObject();
//	  		    //    CustomizedNode node = (CustomizedNode) value;
//	  		          radioButtonRenderer.setText(node.name);
//	  		         // radioButtonRenderer.setSelected(node.isSelected());
//	  		    }
//	  		      returnValue = radioButtonRenderer;
//	  	  	    return returnValue;
//	  	    }
	  	    //} else {
	  	    //  returnValue = nonLeafRenderer.getTreeCellRendererComponent(tree,
	  	    //      value, selected, expanded, leaf, row, hasFocus);
	  	    //}
	  	    return null;
	  	  }
	    
	    

	
	}
